/**
 *Sketch by Rodrigo Shiordia Based on oscP5plug and crontrolp5 examples by andreas schlegel
 fabacademy 2022 interface and application programming
 */

import oscP5.*;
import processing.serial.*;


OscP5 oscP5;
Serial myPort;



int c =color(255);
boolean on=false;
int knobValue=5000;

void setup() {
  size(400, 400);
  String portName = Serial.list()[0];
  println(portName);
  myPort = new Serial(this, portName, 115200);

  frameRate(25);
  oscP5 = new OscP5(this, 8000);
  oscP5.plug(this, "toggle", "/1/toggle1");
  oscP5.plug(this, "slider", "/1/fader1");
}
void draw() {
  background(c);
}
void oscEvent(OscMessage theOscMessage) {
  if (theOscMessage.isPlugged()==false) {
    println("### received an osc message.");
    println("### addrpattern\t"+theOscMessage.addrPattern());
    println("### typetag\t"+theOscMessage.typetag());
  }
}
void toggle(float theValue) {
  if (theValue==1.0) {
    String s="H,"+knobValue+";";
    myPort.write(s);
    on=true;
    c=color(255);
  } else if (theValue==0.0) {
    String s="J,"+knobValue+";";
    myPort.write(s);
    on=false;
    c=color(0);
  }
  println(on);
}
void slider(float theValue) {
  println(theValue);  
  int speed=int(theValue);
  knobValue=speed;
  String s="H,"+knobValue+";";
  if (on) {
    myPort.write(s);
  }
}
